<?php
/*
Plugin Name: SearchBotCall	
Plugin URI: http://morfim.net/2009/04/12/plagin-searchbotcall/
Description: плагин мониторинга захода поисковых ботов
Version: 1.0.0
Author:Morfi
Author URI: http://morfim.net/
*/

$bot_status_file= ABSPATH . 'wp-content/plugins/SearchBotCall/bot_status.txt'; // укажите имя файла

function sbc_output() 
	{
		?>

			<table width="100%" height="100%" border="0" cellpadding="0" cellspacing="0">
				<?php 
					$array=read_bot_status();
					if($array==null)
						{
							echo "<tr><td align=\"center\">";
								echo "Статистики нету";
							echo "</td></tr>";
						}else
					{
						for($i=0;$i<count($array);$i++)
						{	
							$str=explode("--||--",$array[$i]);
							
							
										$base=TimeArray($str[1]); 
										$now=TimeArray(date("Y-m-d H:i:s"));
										$timeINT = mktime($now[2],$now[1],$now[0],$now[4],$now[3],$now[5])-mktime ($base[2],$base[1],$base[0],$base[4],$base[3],$base[5]); //количество секунд разницы
									?>	
							<tr align="center" <?php if($timeINT<=86400){echo "style=\"background:green;\"";}else{if($timeINT>86400 && $timeINT<=172800){echo "style=\"background:yellow;\"";}else{if($timeINT>172800){echo "style=\"background:red;\"";}}}?>>
								<td>
									<b><?php echo $str[0]; ?></b>
								</td>
									
								<td>
									<?php echo $str[1]; ?>
								</td>
							</tr>
							<tr height="3px;">
								<td></td>
							<tr>
					<?php 
						}
					}
				?>

			</table>

		<?php 
	}

function sbc_setup() 
	{
		wp_add_dashboard_widget( 'dashboard_sbc', 'Статистика Поисковых ботов',  'sbc_output');

	}
	
function read_bot_status()
	{
		global $bot_status_file;
		$bst=file($bot_status_file);
		if($bst==false){return null;}else
			{
				return $bst;
			}
	}	
	
function add_bot_status($bot_name,$bot_date)
	{
		global $bot_status_file;
		
		
		$array_bot=read_bot_status();
		$bst = @fopen($bot_status_file, 'w');
		
		if($array_bot==null)
			{
				echo "go1".sizeof($array_bot);
				$value=$bot_name."--||--".$bot_date."\n";
				@fwrite($bst, $value);
			}else
				{
				echo "go2".sizeof($array_bot);
				$type=0;
				for($i=0;$i<sizeof($array_bot);$i++)
					{
								$array_bot[$i]=trim($array_bot[$i]);
								$str=explode("--||--",$array_bot[$i]);
								if($str[0]==$bot_name)
									{
										$value=$bot_name."--||--".$bot_date."\n";
										@fwrite($bst, $value);
										$type=1;
									}else
										{
											@fwrite($bst, $array_bot[$i]."\n");
										}
					}
					if($type==0)
						{
							$value=$bot_name."--||--".$bot_date."\n";
							@fwrite($bst,  $value);
						}
				}
		
		
	}	
	
function head_load()
	{
		include_once( ABSPATH . 'wp-content/plugins/SearchBotCall/bot_ip.php');
		
		$bot_name=null;
		$bot_date=null;
		for($i=0;$i<sizeof($bot_ip);$i++)
			{
				if (preg_match('/'.$bot_ip[$i].'/i', $_SERVER['HTTP_USER_AGENT'] ))
					{   
						$bot_name=$bot_ip[$i];
						$bot_date=date("Y-m-d H:i:s");
					}
			}
		if($bot_name!=null)
			{
				add_bot_status($bot_name,$bot_date);
			}
	}

function TimeArray($time)
	{
		$array=explode(" ",$time);
		$farray=explode("-",$array[0]);
		$larray=explode(":",$array[1]);
		
		$timeArray[0]=$larray[2]; // секунды
		$timeArray[1]=$larray[1]; // минуты
		$timeArray[2]=$larray[0]; // часы
		
		$timeArray[3]=$farray[2]; // день
		$timeArray[4]=$farray[1]; // месяц
		$timeArray[5]=$farray[0]; // год
		
		return $timeArray;
	}
	
add_action('wp_head', 'head_load');
add_action('wp_dashboard_setup', 'sbc_setup');

?>